## 🌐 Contexto

Este desafío gira en torno a la implementación y manipulación de dos estructuras de datos fundamentales: `LinkedLists`.

## 🎯 Objetivos

Este desafío se centra en desarrollar e implementar desde cero estructuras de datos comunes.

Hay un total de 4 objetivos que corresponden a lo siguiente:

1. Implementar la base de una `LinkedList`. Estos son los métodos `insert()` y `delete`. Existen dos tipos de eliminación: `deleteByPosition`, que elimina un nodo basado en la posición pasada como parámetro, y `deleteByValue`, que elimina el primer nodo que contiene el valor pasado como parámetro. Consulta el archivo `linked-list.js` para más información sobre los métodos. Elabora tests para asegurarte de que todas las implemetaciones pasen con éxito antes de continuar.

2. Implementar las funciones para buscar y revertir una lista enlazada (`LinkedList`). Hay dos métodos de búsqueda: uno para buscar si existe un nodo con el valor pasado como parámetro y otro para buscar por posición en la lista. Elabora tests para asegurarte de que todas las implemetaciones pasen con éxito antes de continuar.

### 📂 Estructura del Repositorio

Se proporciona una estructura del repositorio a continuación y no debe ser modificada. Todo lo que necesitas para desarrollar el desafío ya está incluido.

```bash
nuwe-backend-js-data-structures1/
├── data-structures
│   └── linked-list.js
├── index.js
├── jest.config.js
├── package.json
├── package-lock.json
├── README.md
```
